diff --git a/examples/01_helloworld/include/helloworld.h b/examples/c/01_helloworld/include/helloworld.h
similarity index 100%
rename from examples/01_helloworld/include/helloworld.h
rename to examples/c/01_helloworld/include/helloworld.h
diff --git a/examples/01_helloworld/include/helloworld/bake_config.h b/examples/c/01_helloworld/include/helloworld/bake_config.h
similarity index 100%
rename from examples/01_helloworld/include/helloworld/bake_config.h
rename to examples/c/01_helloworld/include/helloworld/bake_config.h
diff --git a/examples/01_helloworld/project.json b/examples/c/01_helloworld/project.json
similarity index 100%
rename from examples/01_helloworld/project.json
rename to examples/c/01_helloworld/project.json
diff --git a/examples/01_helloworld/src/main.c b/examples/c/01_helloworld/src/main.c
similarity index 100%
rename from examples/01_helloworld/src/main.c
rename to examples/c/01_helloworld/src/main.c
diff --git a/examples/02_simple_system/include/simple_system.h b/examples/c/02_simple_system/include/simple_system.h
similarity index 100%
rename from examples/02_simple_system/include/simple_system.h
rename to examples/c/02_simple_system/include/simple_system.h
diff --git a/examples/02_simple_system/include/simple_system/bake_config.h b/examples/c/02_simple_system/include/simple_system/bake_config.h
similarity index 100%
rename from examples/02_simple_system/include/simple_system/bake_config.h
rename to examples/c/02_simple_system/include/simple_system/bake_config.h
diff --git a/examples/02_simple_system/project.json b/examples/c/02_simple_system/project.json
similarity index 100%
rename from examples/02_simple_system/project.json
rename to examples/c/02_simple_system/project.json
diff --git a/examples/02_simple_system/src/main.c b/examples/c/02_simple_system/src/main.c
similarity index 100%
rename from examples/02_simple_system/src/main.c
rename to examples/c/02_simple_system/src/main.c
diff --git a/examples/03_move_system/include/move_system.h b/examples/c/03_move_system/include/move_system.h
similarity index 100%
rename from examples/03_move_system/include/move_system.h
rename to examples/c/03_move_system/include/move_system.h
diff --git a/examples/03_move_system/include/move_system/bake_config.h b/examples/c/03_move_system/include/move_system/bake_config.h
similarity index 100%
rename from examples/03_move_system/include/move_system/bake_config.h
rename to examples/c/03_move_system/include/move_system/bake_config.h
diff --git a/examples/03_move_system/project.json b/examples/c/03_move_system/project.json
similarity index 100%
rename from examples/03_move_system/project.json
rename to examples/c/03_move_system/project.json
diff --git a/examples/03_move_system/src/main.c b/examples/c/03_move_system/src/main.c
similarity index 100%
rename from examples/03_move_system/src/main.c
rename to examples/c/03_move_system/src/main.c
diff --git a/examples/04_simple_module/include/simple_module.h b/examples/c/04_simple_module/include/simple_module.h
similarity index 100%
rename from examples/04_simple_module/include/simple_module.h
rename to examples/c/04_simple_module/include/simple_module.h
diff --git a/examples/04_simple_module/include/simple_module/bake_config.h b/examples/c/04_simple_module/include/simple_module/bake_config.h
similarity index 100%
rename from examples/04_simple_module/include/simple_module/bake_config.h
rename to examples/c/04_simple_module/include/simple_module/bake_config.h
diff --git a/examples/04_simple_module/project.json b/examples/c/04_simple_module/project.json
similarity index 100%
rename from examples/04_simple_module/project.json
rename to examples/c/04_simple_module/project.json
diff --git a/examples/04_simple_module/src/main.c b/examples/c/04_simple_module/src/main.c
similarity index 100%
rename from examples/04_simple_module/src/main.c
rename to examples/c/04_simple_module/src/main.c
diff --git a/examples/04_simple_module/src/simple_module.c b/examples/c/04_simple_module/src/simple_module.c
similarity index 100%
rename from examples/04_simple_module/src/simple_module.c
rename to examples/c/04_simple_module/src/simple_module.c
diff --git a/examples/05_add_remove_system/include/add_remove_system.h b/examples/c/05_add_remove_system/include/add_remove_system.h
similarity index 100%
rename from examples/05_add_remove_system/include/add_remove_system.h
rename to examples/c/05_add_remove_system/include/add_remove_system.h
diff --git a/examples/05_add_remove_system/include/add_remove_system/bake_config.h b/examples/c/05_add_remove_system/include/add_remove_system/bake_config.h
similarity index 100%
rename from examples/05_add_remove_system/include/add_remove_system/bake_config.h
rename to examples/c/05_add_remove_system/include/add_remove_system/bake_config.h
diff --git a/examples/05_add_remove_system/project.json b/examples/c/05_add_remove_system/project.json
similarity index 100%
rename from examples/05_add_remove_system/project.json
rename to examples/c/05_add_remove_system/project.json
diff --git a/examples/05_add_remove_system/src/main.c b/examples/c/05_add_remove_system/src/main.c
similarity index 100%
rename from examples/05_add_remove_system/src/main.c
rename to examples/c/05_add_remove_system/src/main.c
diff --git a/examples/06_set_system/include/set_system.h b/examples/c/06_set_system/include/set_system.h
similarity index 100%
rename from examples/06_set_system/include/set_system.h
rename to examples/c/06_set_system/include/set_system.h
diff --git a/examples/06_set_system/include/set_system/bake_config.h b/examples/c/06_set_system/include/set_system/bake_config.h
similarity index 100%
rename from examples/06_set_system/include/set_system/bake_config.h
rename to examples/c/06_set_system/include/set_system/bake_config.h
diff --git a/examples/06_set_system/project.json b/examples/c/06_set_system/project.json
similarity index 100%
rename from examples/06_set_system/project.json
rename to examples/c/06_set_system/project.json
diff --git a/examples/06_set_system/src/main.c b/examples/c/06_set_system/src/main.c
similarity index 100%
rename from examples/06_set_system/src/main.c
rename to examples/c/06_set_system/src/main.c
diff --git a/examples/07_no_macros/include/no_macros.h b/examples/c/07_no_macros/include/no_macros.h
similarity index 100%
rename from examples/07_no_macros/include/no_macros.h
rename to examples/c/07_no_macros/include/no_macros.h
diff --git a/examples/07_no_macros/include/no_macros/bake_config.h b/examples/c/07_no_macros/include/no_macros/bake_config.h
similarity index 100%
rename from examples/07_no_macros/include/no_macros/bake_config.h
rename to examples/c/07_no_macros/include/no_macros/bake_config.h
diff --git a/examples/07_no_macros/project.json b/examples/c/07_no_macros/project.json
similarity index 100%
rename from examples/07_no_macros/project.json
rename to examples/c/07_no_macros/project.json
diff --git a/examples/07_no_macros/src/main.c b/examples/c/07_no_macros/src/main.c
similarity index 100%
rename from examples/07_no_macros/src/main.c
rename to examples/c/07_no_macros/src/main.c
diff --git a/examples/08_hierarchy/include/hierarchy.h b/examples/c/08_hierarchy/include/hierarchy.h
similarity index 100%
rename from examples/08_hierarchy/include/hierarchy.h
rename to examples/c/08_hierarchy/include/hierarchy.h
diff --git a/examples/08_hierarchy/include/hierarchy/bake_config.h b/examples/c/08_hierarchy/include/hierarchy/bake_config.h
similarity index 100%
rename from examples/08_hierarchy/include/hierarchy/bake_config.h
rename to examples/c/08_hierarchy/include/hierarchy/bake_config.h
diff --git a/examples/08_hierarchy/project.json b/examples/c/08_hierarchy/project.json
similarity index 100%
rename from examples/08_hierarchy/project.json
rename to examples/c/08_hierarchy/project.json
diff --git a/examples/08_hierarchy/src/main.c b/examples/c/08_hierarchy/src/main.c
similarity index 100%
rename from examples/08_hierarchy/src/main.c
rename to examples/c/08_hierarchy/src/main.c
diff --git a/examples/09_hierarchy_api/include/hierarchy_api.h b/examples/c/09_hierarchy_api/include/hierarchy_api.h
similarity index 100%
rename from examples/09_hierarchy_api/include/hierarchy_api.h
rename to examples/c/09_hierarchy_api/include/hierarchy_api.h
diff --git a/examples/09_hierarchy_api/include/hierarchy_api/bake_config.h b/examples/c/09_hierarchy_api/include/hierarchy_api/bake_config.h
similarity index 100%
rename from examples/09_hierarchy_api/include/hierarchy_api/bake_config.h
rename to examples/c/09_hierarchy_api/include/hierarchy_api/bake_config.h
diff --git a/examples/09_hierarchy_api/project.json b/examples/c/09_hierarchy_api/project.json
similarity index 100%
rename from examples/09_hierarchy_api/project.json
rename to examples/c/09_hierarchy_api/project.json
diff --git a/examples/09_hierarchy_api/src/main.c b/examples/c/09_hierarchy_api/src/main.c
similarity index 100%
rename from examples/09_hierarchy_api/src/main.c
rename to examples/c/09_hierarchy_api/src/main.c
diff --git a/examples/10_inheritance/include/inheritance.h b/examples/c/10_inheritance/include/inheritance.h
similarity index 100%
rename from examples/10_inheritance/include/inheritance.h
rename to examples/c/10_inheritance/include/inheritance.h
diff --git a/examples/10_inheritance/include/inheritance/bake_config.h b/examples/c/10_inheritance/include/inheritance/bake_config.h
similarity index 100%
rename from examples/10_inheritance/include/inheritance/bake_config.h
rename to examples/c/10_inheritance/include/inheritance/bake_config.h
diff --git a/examples/10_inheritance/project.json b/examples/c/10_inheritance/project.json
similarity index 100%
rename from examples/10_inheritance/project.json
rename to examples/c/10_inheritance/project.json
diff --git a/examples/10_inheritance/src/main.c b/examples/c/10_inheritance/src/main.c
similarity index 100%
rename from examples/10_inheritance/src/main.c
rename to examples/c/10_inheritance/src/main.c
diff --git a/examples/11_inheritance_api/include/inheritance_api.h b/examples/c/11_inheritance_api/include/inheritance_api.h
similarity index 100%
rename from examples/11_inheritance_api/include/inheritance_api.h
rename to examples/c/11_inheritance_api/include/inheritance_api.h
diff --git a/examples/11_inheritance_api/include/inheritance_api/bake_config.h b/examples/c/11_inheritance_api/include/inheritance_api/bake_config.h
similarity index 100%
rename from examples/11_inheritance_api/include/inheritance_api/bake_config.h
rename to examples/c/11_inheritance_api/include/inheritance_api/bake_config.h
diff --git a/examples/11_inheritance_api/project.json b/examples/c/11_inheritance_api/project.json
similarity index 100%
rename from examples/11_inheritance_api/project.json
rename to examples/c/11_inheritance_api/project.json
diff --git a/examples/11_inheritance_api/src/main.c b/examples/c/11_inheritance_api/src/main.c
similarity index 100%
rename from examples/11_inheritance_api/src/main.c
rename to examples/c/11_inheritance_api/src/main.c
diff --git a/examples/12_override/include/override.h b/examples/c/12_override/include/override.h
similarity index 100%
rename from examples/12_override/include/override.h
rename to examples/c/12_override/include/override.h
diff --git a/examples/12_override/include/override/bake_config.h b/examples/c/12_override/include/override/bake_config.h
similarity index 100%
rename from examples/12_override/include/override/bake_config.h
rename to examples/c/12_override/include/override/bake_config.h
diff --git a/examples/12_override/project.json b/examples/c/12_override/project.json
similarity index 100%
rename from examples/12_override/project.json
rename to examples/c/12_override/project.json
diff --git a/examples/12_override/src/main.c b/examples/c/12_override/src/main.c
similarity index 100%
rename from examples/12_override/src/main.c
rename to examples/c/12_override/src/main.c
diff --git a/examples/13_override_init/include/override_init.h b/examples/c/13_override_init/include/override_init.h
similarity index 100%
rename from examples/13_override_init/include/override_init.h
rename to examples/c/13_override_init/include/override_init.h
diff --git a/examples/13_override_init/include/override_init/bake_config.h b/examples/c/13_override_init/include/override_init/bake_config.h
similarity index 100%
rename from examples/13_override_init/include/override_init/bake_config.h
rename to examples/c/13_override_init/include/override_init/bake_config.h
diff --git a/examples/13_override_init/project.json b/examples/c/13_override_init/project.json
similarity index 100%
rename from examples/13_override_init/project.json
rename to examples/c/13_override_init/project.json
diff --git a/examples/13_override_init/src/main.c b/examples/c/13_override_init/src/main.c
similarity index 100%
rename from examples/13_override_init/src/main.c
rename to examples/c/13_override_init/src/main.c
diff --git a/examples/14_add_type/include/add_type.h b/examples/c/14_add_type/include/add_type.h
similarity index 100%
rename from examples/14_add_type/include/add_type.h
rename to examples/c/14_add_type/include/add_type.h
diff --git a/examples/14_add_type/include/add_type/bake_config.h b/examples/c/14_add_type/include/add_type/bake_config.h
similarity index 100%
rename from examples/14_add_type/include/add_type/bake_config.h
rename to examples/c/14_add_type/include/add_type/bake_config.h
diff --git a/examples/14_add_type/project.json b/examples/c/14_add_type/project.json
similarity index 100%
rename from examples/14_add_type/project.json
rename to examples/c/14_add_type/project.json
diff --git a/examples/14_add_type/src/main.c b/examples/c/14_add_type/src/main.c
similarity index 100%
rename from examples/14_add_type/src/main.c
rename to examples/c/14_add_type/src/main.c
diff --git a/examples/15_auto_override/include/auto_override.h b/examples/c/15_auto_override/include/auto_override.h
similarity index 100%
rename from examples/15_auto_override/include/auto_override.h
rename to examples/c/15_auto_override/include/auto_override.h
diff --git a/examples/15_auto_override/include/auto_override/bake_config.h b/examples/c/15_auto_override/include/auto_override/bake_config.h
similarity index 100%
rename from examples/15_auto_override/include/auto_override/bake_config.h
rename to examples/c/15_auto_override/include/auto_override/bake_config.h
diff --git a/examples/15_auto_override/project.json b/examples/c/15_auto_override/project.json
similarity index 100%
rename from examples/15_auto_override/project.json
rename to examples/c/15_auto_override/project.json
diff --git a/examples/15_auto_override/src/main.c b/examples/c/15_auto_override/src/main.c
similarity index 100%
rename from examples/15_auto_override/src/main.c
rename to examples/c/15_auto_override/src/main.c
diff --git a/examples/16_prefab/include/prefab.h b/examples/c/16_prefab/include/prefab.h
similarity index 100%
rename from examples/16_prefab/include/prefab.h
rename to examples/c/16_prefab/include/prefab.h
diff --git a/examples/16_prefab/include/prefab/bake_config.h b/examples/c/16_prefab/include/prefab/bake_config.h
similarity index 100%
rename from examples/16_prefab/include/prefab/bake_config.h
rename to examples/c/16_prefab/include/prefab/bake_config.h
diff --git a/examples/16_prefab/project.json b/examples/c/16_prefab/project.json
similarity index 100%
rename from examples/16_prefab/project.json
rename to examples/c/16_prefab/project.json
diff --git a/examples/16_prefab/src/main.c b/examples/c/16_prefab/src/main.c
similarity index 100%
rename from examples/16_prefab/src/main.c
rename to examples/c/16_prefab/src/main.c
diff --git a/examples/17_prefab_variant/include/prefab_variant.h b/examples/c/17_prefab_variant/include/prefab_variant.h
similarity index 100%
rename from examples/17_prefab_variant/include/prefab_variant.h
rename to examples/c/17_prefab_variant/include/prefab_variant.h
diff --git a/examples/17_prefab_variant/include/prefab_variant/bake_config.h b/examples/c/17_prefab_variant/include/prefab_variant/bake_config.h
similarity index 100%
rename from examples/17_prefab_variant/include/prefab_variant/bake_config.h
rename to examples/c/17_prefab_variant/include/prefab_variant/bake_config.h
diff --git a/examples/17_prefab_variant/project.json b/examples/c/17_prefab_variant/project.json
similarity index 100%
rename from examples/17_prefab_variant/project.json
rename to examples/c/17_prefab_variant/project.json
diff --git a/examples/17_prefab_variant/src/main.c b/examples/c/17_prefab_variant/src/main.c
similarity index 100%
rename from examples/17_prefab_variant/src/main.c
rename to examples/c/17_prefab_variant/src/main.c
diff --git a/examples/18_nested_prefab/include/nested_prefab.h b/examples/c/18_nested_prefab/include/nested_prefab.h
similarity index 100%
rename from examples/18_nested_prefab/include/nested_prefab.h
rename to examples/c/18_nested_prefab/include/nested_prefab.h
diff --git a/examples/18_nested_prefab/include/nested_prefab/bake_config.h b/examples/c/18_nested_prefab/include/nested_prefab/bake_config.h
similarity index 100%
rename from examples/18_nested_prefab/include/nested_prefab/bake_config.h
rename to examples/c/18_nested_prefab/include/nested_prefab/bake_config.h
diff --git a/examples/18_nested_prefab/project.json b/examples/c/18_nested_prefab/project.json
similarity index 100%
rename from examples/18_nested_prefab/project.json
rename to examples/c/18_nested_prefab/project.json
diff --git a/examples/18_nested_prefab/src/main.c b/examples/c/18_nested_prefab/src/main.c
similarity index 100%
rename from examples/18_nested_prefab/src/main.c
rename to examples/c/18_nested_prefab/src/main.c
diff --git a/examples/19_auto_override_nested_prefab/include/auto_override_nested_prefab.h b/examples/c/19_auto_override_nested_prefab/include/auto_override_nested_prefab.h
similarity index 100%
rename from examples/19_auto_override_nested_prefab/include/auto_override_nested_prefab.h
rename to examples/c/19_auto_override_nested_prefab/include/auto_override_nested_prefab.h
diff --git a/examples/19_auto_override_nested_prefab/include/auto_override_nested_prefab/bake_config.h b/examples/c/19_auto_override_nested_prefab/include/auto_override_nested_prefab/bake_config.h
similarity index 100%
rename from examples/19_auto_override_nested_prefab/include/auto_override_nested_prefab/bake_config.h
rename to examples/c/19_auto_override_nested_prefab/include/auto_override_nested_prefab/bake_config.h
diff --git a/examples/19_auto_override_nested_prefab/project.json b/examples/c/19_auto_override_nested_prefab/project.json
similarity index 100%
rename from examples/19_auto_override_nested_prefab/project.json
rename to examples/c/19_auto_override_nested_prefab/project.json
diff --git a/examples/19_auto_override_nested_prefab/src/main.c b/examples/c/19_auto_override_nested_prefab/src/main.c
similarity index 100%
rename from examples/19_auto_override_nested_prefab/src/main.c
rename to examples/c/19_auto_override_nested_prefab/src/main.c
diff --git a/examples/20_nested_variant/include/nested_variant.h b/examples/c/20_nested_variant/include/nested_variant.h
similarity index 100%
rename from examples/20_nested_variant/include/nested_variant.h
rename to examples/c/20_nested_variant/include/nested_variant.h
diff --git a/examples/20_nested_variant/include/nested_variant/bake_config.h b/examples/c/20_nested_variant/include/nested_variant/bake_config.h
similarity index 100%
rename from examples/20_nested_variant/include/nested_variant/bake_config.h
rename to examples/c/20_nested_variant/include/nested_variant/bake_config.h
diff --git a/examples/20_nested_variant/project.json b/examples/c/20_nested_variant/project.json
similarity index 100%
rename from examples/20_nested_variant/project.json
rename to examples/c/20_nested_variant/project.json
diff --git a/examples/20_nested_variant/src/main.c b/examples/c/20_nested_variant/src/main.c
similarity index 100%
rename from examples/20_nested_variant/src/main.c
rename to examples/c/20_nested_variant/src/main.c
diff --git a/examples/21_system_features/include/system_features.h b/examples/c/21_system_features/include/system_features.h
similarity index 100%
rename from examples/21_system_features/include/system_features.h
rename to examples/c/21_system_features/include/system_features.h
diff --git a/examples/21_system_features/include/system_features/bake_config.h b/examples/c/21_system_features/include/system_features/bake_config.h
similarity index 100%
rename from examples/21_system_features/include/system_features/bake_config.h
rename to examples/c/21_system_features/include/system_features/bake_config.h
diff --git a/examples/21_system_features/project.json b/examples/c/21_system_features/project.json
similarity index 100%
rename from examples/21_system_features/project.json
rename to examples/c/21_system_features/project.json
diff --git a/examples/21_system_features/src/main.c b/examples/c/21_system_features/src/main.c
similarity index 100%
rename from examples/21_system_features/src/main.c
rename to examples/c/21_system_features/src/main.c
diff --git a/examples/22_optional/include/optional.h b/examples/c/22_optional/include/optional.h
similarity index 100%
rename from examples/22_optional/include/optional.h
rename to examples/c/22_optional/include/optional.h
diff --git a/examples/22_optional/include/optional/bake_config.h b/examples/c/22_optional/include/optional/bake_config.h
similarity index 100%
rename from examples/22_optional/include/optional/bake_config.h
rename to examples/c/22_optional/include/optional/bake_config.h
diff --git a/examples/22_optional/project.json b/examples/c/22_optional/project.json
similarity index 100%
rename from examples/22_optional/project.json
rename to examples/c/22_optional/project.json
diff --git a/examples/22_optional/src/main.c b/examples/c/22_optional/src/main.c
similarity index 100%
rename from examples/22_optional/src/main.c
rename to examples/c/22_optional/src/main.c
diff --git a/examples/23_get_children/include/get_children.h b/examples/c/23_get_children/include/get_children.h
similarity index 100%
rename from examples/23_get_children/include/get_children.h
rename to examples/c/23_get_children/include/get_children.h
diff --git a/examples/23_get_children/include/get_children/bake_config.h b/examples/c/23_get_children/include/get_children/bake_config.h
similarity index 100%
rename from examples/23_get_children/include/get_children/bake_config.h
rename to examples/c/23_get_children/include/get_children/bake_config.h
diff --git a/examples/23_get_children/project.json b/examples/c/23_get_children/project.json
similarity index 100%
rename from examples/23_get_children/project.json
rename to examples/c/23_get_children/project.json
diff --git a/examples/23_get_children/src/main.c b/examples/c/23_get_children/src/main.c
similarity index 100%
rename from examples/23_get_children/src/main.c
rename to examples/c/23_get_children/src/main.c
diff --git a/examples/24_on_demand_system/include/on_demand_system.h b/examples/c/24_on_demand_system/include/on_demand_system.h
similarity index 100%
rename from examples/24_on_demand_system/include/on_demand_system.h
rename to examples/c/24_on_demand_system/include/on_demand_system.h
diff --git a/examples/24_on_demand_system/include/on_demand_system/bake_config.h b/examples/c/24_on_demand_system/include/on_demand_system/bake_config.h
similarity index 100%
rename from examples/24_on_demand_system/include/on_demand_system/bake_config.h
rename to examples/c/24_on_demand_system/include/on_demand_system/bake_config.h
diff --git a/examples/24_on_demand_system/project.json b/examples/c/24_on_demand_system/project.json
similarity index 100%
rename from examples/24_on_demand_system/project.json
rename to examples/c/24_on_demand_system/project.json
diff --git a/examples/24_on_demand_system/src/main.c b/examples/c/24_on_demand_system/src/main.c
similarity index 100%
rename from examples/24_on_demand_system/src/main.c
rename to examples/c/24_on_demand_system/src/main.c
diff --git a/examples/25_snapshot/include/snapshot.h b/examples/c/25_snapshot/include/snapshot.h
similarity index 100%
rename from examples/25_snapshot/include/snapshot.h
rename to examples/c/25_snapshot/include/snapshot.h
diff --git a/examples/25_snapshot/include/snapshot/bake_config.h b/examples/c/25_snapshot/include/snapshot/bake_config.h
similarity index 100%
rename from examples/25_snapshot/include/snapshot/bake_config.h
rename to examples/c/25_snapshot/include/snapshot/bake_config.h
diff --git a/examples/25_snapshot/project.json b/examples/c/25_snapshot/project.json
similarity index 100%
rename from examples/25_snapshot/project.json
rename to examples/c/25_snapshot/project.json
diff --git a/examples/25_snapshot/src/main.c b/examples/c/25_snapshot/src/main.c
similarity index 100%
rename from examples/25_snapshot/src/main.c
rename to examples/c/25_snapshot/src/main.c
diff --git a/examples/26_snapshot_w_filter/include/snapshot_w_filter.h b/examples/c/26_snapshot_w_filter/include/snapshot_w_filter.h
similarity index 100%
rename from examples/26_snapshot_w_filter/include/snapshot_w_filter.h
rename to examples/c/26_snapshot_w_filter/include/snapshot_w_filter.h
diff --git a/examples/26_snapshot_w_filter/include/snapshot_w_filter/bake_config.h b/examples/c/26_snapshot_w_filter/include/snapshot_w_filter/bake_config.h
similarity index 100%
rename from examples/26_snapshot_w_filter/include/snapshot_w_filter/bake_config.h
rename to examples/c/26_snapshot_w_filter/include/snapshot_w_filter/bake_config.h
diff --git a/examples/26_snapshot_w_filter/project.json b/examples/c/26_snapshot_w_filter/project.json
similarity index 100%
rename from examples/26_snapshot_w_filter/project.json
rename to examples/c/26_snapshot_w_filter/project.json
diff --git a/examples/26_snapshot_w_filter/src/main.c b/examples/c/26_snapshot_w_filter/src/main.c
similarity index 100%
rename from examples/26_snapshot_w_filter/src/main.c
rename to examples/c/26_snapshot_w_filter/src/main.c
diff --git a/examples/cpp/01_helloworld/.gitignore b/examples/cpp/01_helloworld/.gitignore
new file mode 100644
index 000000000..fff6aadd6
--- /dev/null
+++ b/examples/cpp/01_helloworld/.gitignore
@@ -0,0 +1,5 @@
+.bake_cache
+.DS_Store
+.vscode
+gcov
+bin
diff --git a/examples/cpp/01_helloworld/include/helloworld.h b/examples/cpp/01_helloworld/include/helloworld.h
new file mode 100644
index 000000000..aa7484570
--- /dev/null
+++ b/examples/cpp/01_helloworld/include/helloworld.h
@@ -0,0 +1,16 @@
+#ifndef HELLOWORLD_H
+#define HELLOWORLD_H
+
+/* This generated file contains includes for project dependencies */
+#include "helloworld/bake_config.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+
diff --git a/examples/cpp/01_helloworld/include/helloworld/bake_config.h b/examples/cpp/01_helloworld/include/helloworld/bake_config.h
new file mode 100644
index 000000000..6e50b59e6
--- /dev/null
+++ b/examples/cpp/01_helloworld/include/helloworld/bake_config.h
@@ -0,0 +1,44 @@
+/*
+                                   )
+                                  (.)
+                                  .|.
+                                  | |
+                              _.--| |--._
+                           .-';  ;`-'& ; `&.
+                          \   &  ;    &   &_/
+                           |"""---...---"""|
+                           \ | | | | | | | /
+                            `---.|.|.|.---'
+
+ * This file is generated by bake.lang.c for your convenience. Headers of
+ * dependencies will automatically show up in this file. Include bake_config.h
+ * in your main project file. Do not edit! */
+
+#ifndef HELLOWORLD_BAKE_CONFIG_H
+#define HELLOWORLD_BAKE_CONFIG_H
+
+/* Headers of public dependencies */
+#include <flecs.h>
+
+/* Headers of private dependencies */
+#ifdef HELLOWORLD_IMPL
+/* No dependencies */
+#endif
+
+/* Convenience macro for exporting symbols */
+#ifndef HELLOWORLD_STATIC
+  #if HELLOWORLD_IMPL && (defined(_MSC_VER) || defined(__MINGW32__))
+    #define HELLOWORLD_EXPORT __declspec(dllexport)
+  #elif HELLOWORLD_IMPL
+    #define HELLOWORLD_EXPORT __attribute__((__visibility__("default")))
+  #elif defined _MSC_VER
+    #define HELLOWORLD_EXPORT __declspec(dllimport)
+  #else
+    #define HELLOWORLD_EXPORT
+  #endif
+#else
+  #define HELLOWORLD_EXPORT
+#endif
+
+#endif
+
diff --git a/examples/cpp/01_helloworld/project.json b/examples/cpp/01_helloworld/project.json
new file mode 100644
index 000000000..25ba91e11
--- /dev/null
+++ b/examples/cpp/01_helloworld/project.json
@@ -0,0 +1,12 @@
+{
+    "id": "helloworld",
+    "type": "application",
+    "value": {
+        "author": "Jane Doe",
+        "description": "A simple hello world flecs application",
+        "use": [
+            "flecs"
+        ],
+        "language": "c++"
+    }
+}
\ No newline at end of file
diff --git a/examples/cpp/01_helloworld/src/main.cpp b/examples/cpp/01_helloworld/src/main.cpp
new file mode 100644
index 000000000..2eb143a6a
--- /dev/null
+++ b/examples/cpp/01_helloworld/src/main.cpp
@@ -0,0 +1,15 @@
+#include <helloworld.h>
+#include "flecs/flecs.hpp"
+
+int main(int argc, char *argv[]) {
+    /* Create the world, pass arguments for overriding the number of threads,fps
+     * or for starting the admin dashboard (see flecs.h for details). */
+    flecs::world world(argc, argv);
+
+    world.set_target_fps(60);
+
+    std::cout << "Application helloworld is running, press CTRL-C to exit..." << std::endl;
+
+    /* Run systems */
+    while (world.progress()) { }
+}
diff --git a/examples/cpp/02_simple_system/.gitignore b/examples/cpp/02_simple_system/.gitignore
new file mode 100644
index 000000000..fff6aadd6
--- /dev/null
+++ b/examples/cpp/02_simple_system/.gitignore
@@ -0,0 +1,5 @@
+.bake_cache
+.DS_Store
+.vscode
+gcov
+bin
diff --git a/examples/cpp/02_simple_system/include/simple_system.h b/examples/cpp/02_simple_system/include/simple_system.h
new file mode 100644
index 000000000..ec6497bfe
--- /dev/null
+++ b/examples/cpp/02_simple_system/include/simple_system.h
@@ -0,0 +1,16 @@
+#ifndef SIMPLE_SYSTEM_H
+#define SIMPLE_SYSTEM_H
+
+/* This generated file contains includes for project dependencies */
+#include "simple_system/bake_config.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+
diff --git a/examples/cpp/02_simple_system/include/simple_system/bake_config.h b/examples/cpp/02_simple_system/include/simple_system/bake_config.h
new file mode 100644
index 000000000..9416296ee
--- /dev/null
+++ b/examples/cpp/02_simple_system/include/simple_system/bake_config.h
@@ -0,0 +1,44 @@
+/*
+                                   )
+                                  (.)
+                                  .|.
+                                  | |
+                              _.--| |--._
+                           .-';  ;`-'& ; `&.
+                          \   &  ;    &   &_/
+                           |"""---...---"""|
+                           \ | | | | | | | /
+                            `---.|.|.|.---'
+
+ * This file is generated by bake.lang.c for your convenience. Headers of
+ * dependencies will automatically show up in this file. Include bake_config.h
+ * in your main project file. Do not edit! */
+
+#ifndef SIMPLE_SYSTEM_BAKE_CONFIG_H
+#define SIMPLE_SYSTEM_BAKE_CONFIG_H
+
+/* Headers of public dependencies */
+#include <flecs.h>
+
+/* Headers of private dependencies */
+#ifdef SIMPLE_SYSTEM_IMPL
+/* No dependencies */
+#endif
+
+/* Convenience macro for exporting symbols */
+#ifndef SIMPLE_SYSTEM_STATIC
+  #if SIMPLE_SYSTEM_IMPL && (defined(_MSC_VER) || defined(__MINGW32__))
+    #define SIMPLE_SYSTEM_EXPORT __declspec(dllexport)
+  #elif SIMPLE_SYSTEM_IMPL
+    #define SIMPLE_SYSTEM_EXPORT __attribute__((__visibility__("default")))
+  #elif defined _MSC_VER
+    #define SIMPLE_SYSTEM_EXPORT __declspec(dllimport)
+  #else
+    #define SIMPLE_SYSTEM_EXPORT
+  #endif
+#else
+  #define SIMPLE_SYSTEM_EXPORT
+#endif
+
+#endif
+
diff --git a/examples/cpp/02_simple_system/project.json b/examples/cpp/02_simple_system/project.json
new file mode 100644
index 000000000..66042e62e
--- /dev/null
+++ b/examples/cpp/02_simple_system/project.json
@@ -0,0 +1,12 @@
+{
+    "id": "simple_system",
+    "type": "application",
+    "value": {
+        "author": "Jane Doe",
+        "description": "A simple hello world flecs application",
+        "use": [
+            "flecs"
+        ],
+        "language": "c++"
+    }
+}
\ No newline at end of file
diff --git a/examples/cpp/02_simple_system/src/main.cpp b/examples/cpp/02_simple_system/src/main.cpp
new file mode 100644
index 000000000..335030ca4
--- /dev/null
+++ b/examples/cpp/02_simple_system/src/main.cpp
@@ -0,0 +1,32 @@
+#include <simple_system.h>
+#include "flecs/flecs.hpp"
+
+/* Component type */
+typedef struct Message {
+    const char *text;
+} Message;
+
+int main(int argc, char *argv[]) {
+    /* Create the world, pass arguments for overriding the number of threads,fps
+     * or for starting the admin dashboard (see flecs.h for details). */
+    flecs::world world(argc, argv);
+
+    flecs::component<Message>(world, "Message");
+
+    flecs::system<Message>(world)
+        .action([](const flecs::rows& rows, flecs::column<Message> messages) {
+            for (auto row : rows) {
+                std::cout << messages[row].text << std::endl;
+            }
+        });
+
+    flecs::entity(world)
+        .set<Message>({"Hello Flecs!"});
+
+    world.set_target_fps(1);
+
+    std::cout << "Application simple_system is running, press CTRL-C to exit..." << std::endl;
+
+    /* Run systems */
+    while (world.progress()) { }
+}
diff --git a/examples/cpp/03_move_system/.gitignore b/examples/cpp/03_move_system/.gitignore
new file mode 100644
index 000000000..fff6aadd6
--- /dev/null
+++ b/examples/cpp/03_move_system/.gitignore
@@ -0,0 +1,5 @@
+.bake_cache
+.DS_Store
+.vscode
+gcov
+bin
diff --git a/examples/cpp/03_move_system/include/move_system.h b/examples/cpp/03_move_system/include/move_system.h
new file mode 100644
index 000000000..ca50325b1
--- /dev/null
+++ b/examples/cpp/03_move_system/include/move_system.h
@@ -0,0 +1,16 @@
+#ifndef MOVE_SYSTEM_H
+#define MOVE_SYSTEM_H
+
+/* This generated file contains includes for project dependencies */
+#include "move_system/bake_config.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+
diff --git a/examples/cpp/03_move_system/include/move_system/bake_config.h b/examples/cpp/03_move_system/include/move_system/bake_config.h
new file mode 100644
index 000000000..a7746dbbe
--- /dev/null
+++ b/examples/cpp/03_move_system/include/move_system/bake_config.h
@@ -0,0 +1,44 @@
+/*
+                                   )
+                                  (.)
+                                  .|.
+                                  | |
+                              _.--| |--._
+                           .-';  ;`-'& ; `&.
+                          \   &  ;    &   &_/
+                           |"""---...---"""|
+                           \ | | | | | | | /
+                            `---.|.|.|.---'
+
+ * This file is generated by bake.lang.c for your convenience. Headers of
+ * dependencies will automatically show up in this file. Include bake_config.h
+ * in your main project file. Do not edit! */
+
+#ifndef MOVE_SYSTEM_BAKE_CONFIG_H
+#define MOVE_SYSTEM_BAKE_CONFIG_H
+
+/* Headers of public dependencies */
+#include <flecs.h>
+
+/* Headers of private dependencies */
+#ifdef MOVE_SYSTEM_IMPL
+/* No dependencies */
+#endif
+
+/* Convenience macro for exporting symbols */
+#ifndef MOVE_SYSTEM_STATIC
+  #if MOVE_SYSTEM_IMPL && (defined(_MSC_VER) || defined(__MINGW32__))
+    #define MOVE_SYSTEM_EXPORT __declspec(dllexport)
+  #elif MOVE_SYSTEM_IMPL
+    #define MOVE_SYSTEM_EXPORT __attribute__((__visibility__("default")))
+  #elif defined _MSC_VER
+    #define MOVE_SYSTEM_EXPORT __declspec(dllimport)
+  #else
+    #define MOVE_SYSTEM_EXPORT
+  #endif
+#else
+  #define MOVE_SYSTEM_EXPORT
+#endif
+
+#endif
+
diff --git a/examples/cpp/03_move_system/project.json b/examples/cpp/03_move_system/project.json
new file mode 100644
index 000000000..2a1480029
--- /dev/null
+++ b/examples/cpp/03_move_system/project.json
@@ -0,0 +1,12 @@
+{
+    "id": "move_system",
+    "type": "application",
+    "value": {
+        "author": "Jane Doe",
+        "description": "A simple hello world flecs application",
+        "use": [
+            "flecs"
+        ],
+        "language": "c++"
+    }
+}
\ No newline at end of file
diff --git a/examples/cpp/03_move_system/src/main.cpp b/examples/cpp/03_move_system/src/main.cpp
new file mode 100644
index 000000000..7fe4e633c
--- /dev/null
+++ b/examples/cpp/03_move_system/src/main.cpp
@@ -0,0 +1,47 @@
+#include <move_system.h>
+#include "flecs/flecs.hpp"
+
+/* Component types */
+typedef struct Position {
+    float x;
+    float y;
+} Position;
+
+typedef struct Velocity {
+    float x;
+    float y;
+} Velocity;
+
+int main(int argc, char *argv[]) {
+    /* Create the world, pass arguments for overriding the number of threads,fps
+     * or for starting the admin dashboard (see flecs.h for details). */
+    flecs::world world(argc, argv);
+
+    flecs::component<Position>(world, "Position");
+    flecs::component<Velocity>(world, "Velocity");
+
+    flecs::system<Position, Velocity>(world)
+        .action([](const flecs::rows& rows, 
+            flecs::column<Position> p, 
+            flecs::column<Velocity> v) 
+        {    
+            for (auto row : rows) {
+                p[row].x += v[row].x;
+                p[row].y += v[row].y;
+
+                std::cout << "Moved " << rows.entity(row).name() << "to {" <<
+                    p[row].x << ", " << p[row].y << "}" << std::endl;
+            }
+        });
+
+    flecs::entity(world, "MyEntity")
+        .set<Position>({0, 0})
+        .set<Velocity>({1, 1});
+
+    world.set_target_fps(1);
+
+    std::cout << "Application move_system is running, press CTRL-C to exit..." << std::endl;
+
+    /* Run systems */
+    while (world.progress()) { }
+}
diff --git a/include/flecs/flecs.hpp b/include/flecs/flecs.hpp
index 0d86b0289..23f38e688 100644
--- a/include/flecs/flecs.hpp
+++ b/include/flecs/flecs.hpp
@@ -118,11 +118,14 @@ class rows final {
         return ecs_is_readonly(m_rows, column);
     }
 
+    /* Obtain entity being iterated over for row */
+    flecs::entity entity(uint32_t row) const;
+
     /* Obtain column source (0 if self) */
-    entity column_source(uint32_t column) const;
+    flecs::entity column_source(uint32_t column) const;
 
     /* Obtain component/tag entity of column */
-    entity column_entity(uint32_t column) const;
+    flecs::entity column_entity(uint32_t column) const;
 
     /* Obtain type of column */
     flecs::type column_type(uint32_t column) const;
@@ -734,14 +737,19 @@ entity world::lookup_child(const entity& parent, const char *name) const {
 
 /* -- rows implementation -- */
 
+flecs::entity rows::entity(uint32_t row) const {
+    ecs_assert(row < m_rows->count, ECS_COLUMN_INDEX_OUT_OF_RANGE, NULL);
+    return flecs::entity(m_rows->world, m_rows->entities[row]);
+}
+
 /* Obtain column source (0 if self) */
-entity rows::column_source(uint32_t column) const {
-    return entity(m_rows->world, ecs_column_source(m_rows, column));
+flecs::entity rows::column_source(uint32_t column) const {
+    return flecs::entity(m_rows->world, ecs_column_source(m_rows, column));
 }
 
 /* Obtain component/tag entity of column */
-entity rows::column_entity(uint32_t column) const {
-    return entity(m_rows->world, ecs_column_entity(m_rows, column));
+flecs::entity rows::column_entity(uint32_t column) const {
+    return flecs::entity(m_rows->world, ecs_column_entity(m_rows, column));
 }
 
 /* Obtain type of column */
diff --git a/src/world.c b/src/world.c
index 7bf22958e..4b7aa6f5d 100644
--- a/src/world.c
+++ b/src/world.c
@@ -982,6 +982,10 @@ ecs_entity_t ecs_lookup_child_in_columns(
     uint32_t i, count = ecs_vector_count(column->data);
     
     for (i = 0; i < count; i ++) {
+        if (!buffer[i]) {
+            continue;
+        }
+        
         if (!strcmp(buffer[i], id)) {
             return *(ecs_entity_t*)ecs_vector_get(
                 columns[0].data, &handle_arr_params, i);
diff --git a/templates/flecs-graphics/.gitignore b/templates/c/flecs-graphics/.gitignore
similarity index 100%
rename from templates/flecs-graphics/.gitignore
rename to templates/c/flecs-graphics/.gitignore
diff --git a/templates/flecs-graphics/include/__id_underscore.h b/templates/c/flecs-graphics/include/__id_underscore.h
similarity index 100%
rename from templates/flecs-graphics/include/__id_underscore.h
rename to templates/c/flecs-graphics/include/__id_underscore.h
diff --git a/templates/flecs-graphics/project.json b/templates/c/flecs-graphics/project.json
similarity index 100%
rename from templates/flecs-graphics/project.json
rename to templates/c/flecs-graphics/project.json
diff --git a/templates/flecs-graphics/src/main.c b/templates/c/flecs-graphics/src/main.c
similarity index 100%
rename from templates/flecs-graphics/src/main.c
rename to templates/c/flecs-graphics/src/main.c
diff --git a/templates/flecs-module/.gitignore b/templates/c/flecs-module/.gitignore
similarity index 100%
rename from templates/flecs-module/.gitignore
rename to templates/c/flecs-module/.gitignore
diff --git a/templates/flecs-module/include/__id_underscore.h b/templates/c/flecs-module/include/__id_underscore.h
similarity index 100%
rename from templates/flecs-module/include/__id_underscore.h
rename to templates/c/flecs-module/include/__id_underscore.h
diff --git a/templates/flecs-module/project.json b/templates/c/flecs-module/project.json
similarity index 100%
rename from templates/flecs-module/project.json
rename to templates/c/flecs-module/project.json
diff --git a/templates/flecs-module/src/main.c b/templates/c/flecs-module/src/main.c
similarity index 100%
rename from templates/flecs-module/src/main.c
rename to templates/c/flecs-module/src/main.c
diff --git a/templates/flecs/.gitignore b/templates/c/flecs/.gitignore
similarity index 100%
rename from templates/flecs/.gitignore
rename to templates/c/flecs/.gitignore
diff --git a/templates/flecs/include/__id_underscore.h b/templates/c/flecs/include/__id_underscore.h
similarity index 100%
rename from templates/flecs/include/__id_underscore.h
rename to templates/c/flecs/include/__id_underscore.h
diff --git a/templates/flecs/project.json b/templates/c/flecs/project.json
similarity index 100%
rename from templates/flecs/project.json
rename to templates/c/flecs/project.json
diff --git a/templates/flecs/src/main.c b/templates/c/flecs/src/main.c
similarity index 100%
rename from templates/flecs/src/main.c
rename to templates/c/flecs/src/main.c
diff --git a/templates/cpp/flecs/.gitignore b/templates/cpp/flecs/.gitignore
new file mode 100644
index 000000000..335606867
--- /dev/null
+++ b/templates/cpp/flecs/.gitignore
@@ -0,0 +1,4 @@
+.bake_cache
+.DS_Store
+.vscode
+bin
diff --git a/templates/cpp/flecs/include/__id_underscore.h b/templates/cpp/flecs/include/__id_underscore.h
new file mode 100644
index 000000000..93984710e
--- /dev/null
+++ b/templates/cpp/flecs/include/__id_underscore.h
@@ -0,0 +1,16 @@
+#ifndef ${id upper}_H
+#define ${id upper}_H
+
+/* This generated file contains includes for project dependencies */
+#include "${id dash}/bake_config.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
+
diff --git a/templates/cpp/flecs/project.json b/templates/cpp/flecs/project.json
new file mode 100644
index 000000000..a071f3a35
--- /dev/null
+++ b/templates/cpp/flecs/project.json
@@ -0,0 +1,10 @@
+{
+    "id": "flecs",
+    "type": "template",
+    "value": {
+        "author": "Jane Doe",
+        "description": "A simple hello world flecs application",
+        "use": ["flecs"],
+        "language": "c++"
+    }
+}
diff --git a/templates/cpp/flecs/src/main.cpp b/templates/cpp/flecs/src/main.cpp
new file mode 100644
index 000000000..972db4cd0
--- /dev/null
+++ b/templates/cpp/flecs/src/main.cpp
@@ -0,0 +1,15 @@
+#include <${id underscore}.h>
+#include "flecs/flecs.hpp"
+
+int main(int argc, char *argv[]) {
+    /* Create the world, pass arguments for overriding the number of threads,fps
+     * or for starting the admin dashboard (see flecs.h for details). */
+    flecs::world world(argc, argv);
+
+    world.set_target_fps(60);
+
+    std::cout << "Application ${id} is running, press CTRL-C to exit..." << std::endl;
+
+    /* Run systems */
+    while (world.progress()) { }
+}
